' TestDB.mdb ̍쐬Bdata01.csv, data02.csv 荞ށB
Option Explicit
Dim MdbObj, FSO, DbName, DbPath, TblName, TypeStr, CsvFile, sql

RunOn32bit  ' 32bitR}hœXNvgs
Set MdbObj = New DbAdo
Set FSO = CreateObject("Scripting.FileSystemObject")
DbName = "TestDB.mdb"
DbPath = FSO.GetAbsolutePathName(DbName)
If FSO.FileExists(DbPath) Then FSO.DeleteFile(DbPath)
Set FSO = Nothing
MdbObj.Open DbPath

TblName = "TableA"
TypeStr = "ID int PRIMARY KEY,  varchar(6) NOT NULL, " & _
    "g decimal(5,2), ̏d float"
CsvFile = "data01.csv"
MakeTableFromCSV MdbObj, TblName, TypeStr, CsvFile

TblName = "TableB"
TypeStr = "ID int PRIMARY KEY, E varchar(10), " & _
    "Ƌ̗L YesNo DEFAULT false, N date"
CsvFile = "data02.csv"
MakeTableFromCSV MdbObj, TblName, TypeStr, CsvFile

sql = "create view TableMerge as" & vbCrLf & _
    "select TableA.*," & vbCrLf & _
    "TableB.E, TableB.Ƌ̗L, TableB.N" & vbCrLf & _
    "from TableA, TableB" & vbCrLf & _
    "where TableA.ID = TableB.ID;"
MdbObj.CN.Execute(sql)
MdbObj.Close
Set MdbObj = Nothing

' ----------------

' 32bitł WScript.exe, CScript.exe ɂXNvgs
Public Sub RunOn32bit
    Dim p_objWshShell, p_admArg, p_admArrayArguments
    Dim p_admWscriptCscript, p_admCommand
    Set p_objWshShell = CreateObject("Wscript.Shell")
    If p_objWshShell.Environment("Process").Item( _
      "PROCESSOR_ARCHITECTURE") <> "x86" Then
        If Not WScript.Arguments.Count = 0 Then
            For Each p_admArg In Wscript.Arguments
              p_admArrayArguments = p_admArrayArguments & _
                  " """ & p_admArg & """"
            Next
        End If
        If InStr(LCase(WScript.FullName), "wscript") > 0 Then
            p_admWscriptCscript = "WScript.exe"
        Else
            p_admWscriptCscript = "CScript.exe"
        End If
        p_admCommand = """" & p_objWshShell.Environment("Process").Item( _
            "windir") & "\SysWOW64\" & p_admWscriptCscript & """ """ & _
            WScript.ScriptFullName & """" & p_admArrayArguments
        p_objWshShell.Run p_admCommand
        WScript.Quit
    End If
End Sub

' ----------------

Class DbAdo
    Private pDbPath
    Private pConnStr
    Private pCN
    Private pCAT
    Public TBL
    Public RS

    Private Sub Class_Initialize
        pDbPath = ""
        pConnStr = ""
        Set pCN = Nothing
        Set pCAT = Nothing
        TBL = ""
        Set RS = Nothing
    End Sub

    Private Sub Class_Terminate
        Call Close()
    End Sub

    Public Property Get DbPath
        DbPath = pDbPath
    End Property

    Public Property Get ConnStr
        ConnStr = pConnStr
    End Property

    Public Property Get CN
        Set CN = pCN
    End Property

    Public Property Get CAT
        Set CAT = pCAT
    End Property

    Public Sub Close()
        On Error Resume Next
        If Not pCN Is Nothing Then pCN.Close
        On Error Resume Next
        If Not RS Is Nothing Then RS.Close
        pDbPath = ""
        pConnStr = ""
        Set pCN = Nothing
        Set pCAT = Nothing
        TBL = ""
        Set RS = Nothing
    End Sub

    Public Sub Open(ByVal DbName)  ' DataBase open
        Dim ShellObj, FSO, DriverStr, ExtName
        Call Close()
        Set ShellObj = CreateObject("Wscript.Shell")
        If ShellObj.Environment("Process").Item( _
                "PROCESSOR_ARCHITECTURE") = "x86" Then  ' 32bitł̏ꍇ
            DriverStr = "Provider=Microsoft.Jet.OLEDB.4.0;"
        Else  ' 64bitł̏ꍇ
            DriverStr = "Provider=Microsoft.ACE.OLEDB.12.0;"
        End If
        Set ShellObj = Nothing
        Set FSO = CreateObject("Scripting.FileSystemObject")
        pDbPath = FSO.GetAbsolutePathName(DbName)
        ExtName = LCase(FSO.GetExtensionName(pDbPath))
        Select Case ExtName
        Case "mdb"
            pConnStr = DriverStr & "Data Source=" & pDbPath & ";"
        Case "xls"
            pConnStr = DriverStr & "Data Source=" & pDbPath & ";" & _
                "Extended Properties=""Excel 8.0;HDR=Yes;"""
        Case "accdb"
            pConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
                "Data Source=" & pDbPath & ";"
        Case "xlsx"
            pConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
                "Data Source=" & pDbPath & ";" & _
                "Extended Properties=""Excel 12.0 XML;HDR=Yes;"""
        Case Else
            pConnStr = ""
        End Select
        If pConnStr = "" Then
            Set pCN = Nothing
            Set pCAT = Nothing
            Exit Sub
        End If
        If (FSO.FileExists(pDbPath) = False) And ((ExtName = "mdb") Or _
            (ExtName = "accdb")) Then
            Set pCAT = CreateObject("ADOX.Catalog")
            Set pCN = pCAT.Create(pConnStr)  ' f[^x[XVK쐬
        Else
            Set pCN = CreateObject("ADODB.Connection")
            pCN.Open pConnStr
            Set pCAT = CreateObject("ADOX.Catalog")
            pCAT.ActiveConnection = pCN
        End If
        Set FSO = Nothing
    End Sub

    Public Sub OpenCSV(ByVal CsvFile, ByVal HeaderYN)
        Dim FSO, CsvPath, CsvFolder, CsvTable, ShellObj, DriverStr
        Set FSO = CreateObject("Scripting.FileSystemObject")
        CsvPath = FSO.GetAbsolutePathName(CsvFile)
        CsvFolder = FSO.GetParentFolderName(CsvPath)
        If FSO.FolderExists(CsvFolder) = False Then
            On Error Resume Next
            FSO.CreateFolder(CsvFolder)
            If FSO.FolderExists(CsvFolder) = False Then
                WScript.Echo CsvFolder & "݂܂!"
                Exit Sub
            End If
        End If
        CsvTable = FSO.GetFileName(CsvPath)
        Set FSO = Nothing
        Call Close()
        pDbPath = CsvFolder
        TBL = CsvTable

        Set ShellObj = CreateObject("Wscript.Shell")
        If ShellObj.Environment("Process").Item( _
                "PROCESSOR_ARCHITECTURE") = "x86" Then  ' 32bitł̏ꍇ
            DriverStr = "Provider=Microsoft.Jet.OLEDB.4.0;"
        Else  ' 64bitł̏ꍇ
            DriverStr = "Provider=Microsoft.ACE.OLEDB.12.0;"
        End If
        Set ShellObj = Nothing

        pConnStr = DriverStr & "Data Source=" & CsvFolder & ";" & _
            "Extended Properties=""text;HDR=" & HeaderYN & ";FMT=Delimited;"";"
        Set pCN = CreateObject("ADODB.Connection")
        pCN.Open pConnStr
        Set pCAT = CreateObject("ADOX.Catalog")
        pCAT.ActiveConnection = pCN
    End Sub

    Public Sub OpenReadRS
        Dim TblName
        If TBL = "" Then  Exit Sub
        TblName = "[" & Replace(TBL, ".", "#") & "]"
        Set RS = CreateObject("ADODB.Recordset")
        RS.Open TblName, pCN, 0, 1, 2
    End Sub

    Public Sub OpenRS
        Dim TblName
        If TBL = "" Then  Exit Sub
        TblName = "[" & Replace(TBL, ".", "#") & "]"
        Set RS = CreateObject("ADODB.Recordset")
        RS.Open TblName, pCN, 0, 2, 2
    End Sub
End Class

' ----------------

Sub MakeTableFromCSV(MdbObj, ByVal TblName, ByVal TypeStr, ByVal CsvFile)
    Dim sql, i, CsvObj

    sql = "create table " & TblName & " (" & TypeStr & ");"
    MdbObj.CN.Execute(sql)
    MdbObj.TBL = TblName
    MdbObj.OpenRS

    Set CsvObj = New DbAdo
    CsvObj.OpenCSV CsvFile, "Yes"
    CsvObj.OpenReadRS

    Do Until CsvObj.RS.EOF
        MdbObj.RS.AddNew
        For i = 0 To (CsvObj.RS.Fields.Count-1)
            MdbObj.RS.Fields(i).Value = CsvObj.RS.Fields(i).Value
        Next
        MdbObj.RS.Update
        CsvObj.RS.MoveNext
    Loop
    CsvObj.Close
    Set CsvObj = Nothing
    MdbObj.RS.Close
    Set MdbObj.RS = Nothing
End Sub
