' ADOɂAccessExcel̕ϊ
Option Explicit
Dim FSO, DbName, DbPath, BookName, BookPath
Dim Mdb, Xls, MdbTbl, XlsTbl, TblName, FldNames
Dim MdbRS, XlsRS, MdbCol, XlsCol, i

Set FSO = CreateObject("Scripting.FileSystemObject")
DbName = InputBox("Accesst@C̖OF@", _
    "AccessExcel", "TestDB.mdb")
If DbName = "" Then WScript.Quit
DbPath = FSO.GetAbsolutePathName(DbName)
If FSO.FileExists(DbPath) = False Then
    MsgBox "t@C݂܂: " & DbPath
    WScript.Quit
End If
Set Mdb = New DbAdo
Mdb.Open DbPath

BookName = "Book1.xls"
BookPath = FSO.GetAbsolutePathName(BookName)
If FSO.FileExists(BookPath) Then FSO.DeleteFile(BookPath)
Set Xls = New DbAdo
Xls.Open BookPath

For Each MdbTbl In Mdb.CAT.Tables  ' e[uǂ
    If (MdbTbl.Type = "TABLE") Or (MdbTbl.Type = "VIEW") Then
        TblName = "[" & MdbTbl.Name & "]"
        FldNames = FieldNamesNotBin(Mdb.CN, TblName)
        Set XlsTbl = CreateObject("ADOX.Table")  ' VTableIuWFNg
        XlsTbl.Name = MdbTbl.Name  ' e[uRs[
        For i = 0 To UBound(FldNames)  ' tB[h
            Set MdbCol = MdbTbl.Columns(FldNames(i))
            Set XlsCol = CreateObject("ADOX.Column")  ' VFieldIuWFNg
            XlsCol.Name = MdbCol.Name
            XlsCol.Type = MdbCol.Type
            XlsCol.DefinedSize = MdbCol.DefinedSize
            XlsCol.Precision = MdbCol.Precision
            XlsCol.NumericScale = MdbCol.NumericScale
            XlsCol.ParentCatalog = Xls.CAT  ' Ô
            XlsTbl.Columns.Append XlsCol  ' Field`Tableɒǉ
        Next
        Xls.CAT.Tables.Append XlsTbl  ' Table̒`
    Set MdbRS = CreateObject("ADODB.Recordset")
        MdbRS.Open TblName, Mdb.CN, 0, 1, 2
        Set XlsRS = CreateObject("ADODB.Recordset")
        XlsRS.Open TblName, Xls.CN, 0, 2, 2
        Do Until MdbRS.EOF  ' mdb̃R[hxlsɃRs[
            XlsRS.AddNew
            For i = 0 To UBound(FldNames)
                XlsRS.Fields(FldNames(i)).Value = _
                    MdbRS.Fields(FldNames(i)).Value
            Next
            XlsRS.Update
            MdbRS.MoveNext
        Loop
        MdbRS.Close
        XlsRS.Close
    End If
Next
Xls.Close
Mdb.Close
ExcelAutoFit BookPath

' ----------------

Function FieldNamesNotBin(CN, TblName)  ' tB[h̎擾
    Dim RS, FldNames, FldCount, ValStr, i
    Set RS = CreateObject("ADODB.Recordset")
    RS.Open TblName, CN, 0, 1, 2
    Set FldNames = CreateObject("System.Collections.ArrayList")
    FldCount = RS.Fields.Count
    For i = 0 To (FldCount-1)
        ValStr = "@" & CStr(RS.Fields(i).Type) & "@"
        If InStr("@128@204@205@", ValStr) = 0 Then  ' oCił͂Ȃ
            FldNames.Add RS.Fields(i).Name
        End If
    Next
    RS.Close
    FieldNamesNotBin = FldNames.ToArray()
End Function

' ----------------

Class DbAdo
    Public DbPath
    Public ConnStr
    Public CN
    Public CAT

    Private Sub Class_Initialize
        DbPath = ""
        ConnStr = ""
        Set CN = Nothing
        Set CAT = Nothing
    End Sub

    Private Sub Class_Terminate
        Call Close()
    End Sub

    Public Sub Open(ByVal DbName)  ' DataBase open
        Dim ShellObj, FSO, DriverStr, ExtName
        Set ShellObj = CreateObject("Wscript.Shell")
        If ShellObj.Environment("Process").Item( _
                "PROCESSOR_ARCHITECTURE") = "x86" Then  ' 32bitł̏ꍇ
            DriverStr = "Provider=Microsoft.Jet.OLEDB.4.0;"
        Else  ' 64bitł̏ꍇ
            DriverStr = "Provider=Microsoft.ACE.OLEDB.12.0;"
        End If
        Set ShellObj = Nothing
        Set FSO = CreateObject("Scripting.FileSystemObject")
        DbPath = FSO.GetAbsolutePathName(DbName)
        ExtName = LCase(FSO.GetExtensionName(DbPath))
        Select Case ExtName
        Case "mdb"
            ConnStr = DriverStr & "Data Source=" & DbPath & ";"
        Case "xls"
            ConnStr = DriverStr & "Data Source=" & DbPath & ";" & _
                "Extended Properties=""Excel 8.0;HDR=Yes;"""
        Case "accdb"
            ConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
                "Data Source=" & DbPath & ";"
        Case "xlsx"
            ConnStr = "Provider=Microsoft.ACE.OLEDB.12.0;" & _
                "Data Source=" & DbPath & ";" & _
                "Extended Properties=""Excel 12.0 XML;HDR=Yes;"""
        Case Else
            ConnStr = ""
        End Select
        If ConnStr = "" Then
            Set CN = Nothing
            Set CAT = Nothing
            Exit Sub
        End If
        If (FSO.FileExists(DbPath) = False) And ((ExtName = "mdb") Or _
            (ExtName = "accdb")) Then
            Set CAT = CreateObject("ADOX.Catalog")
            Set CN = CAT.Create(ConnStr)  ' f[^x[XVK쐬
        Else
            Set CN = CreateObject("ADODB.Connection")
            CN.Open ConnStr
            Set CAT = CreateObject("ADOX.Catalog")
            CAT.ActiveConnection = CN
        End If
        Set FSO = Nothing
    End Sub

    Public Sub Close()
        If Not CN Is Nothing Then CN.Close
        DbPath = ""
        ConnStr = ""
        Set CN = Nothing
        Set CAT = Nothing
    End Sub
End Class

' ----------------

Sub ExcelAutoFit(ByVal BookPath)  ' SV[g̃Z𒲐
    Dim EXLapp, WBobj, WSobj, Col
    Set EXLapp = CreateObject("Excel.Application")  ' Excel̋N
    EXLapp.Visible = True  ' ExcelԂ
    Set WBobj = EXLapp.Workbooks.Open(BookPath)
    For Each WSobj In WBobj.Worksheets
        WSobj.UsedRange.Columns.AutoFit
    Next
    WBobj.Save  ' [NubN̏㏑ۑ
    EXLapp.quit
End Sub
